#
# spec file for package ksh (Version 93r)
#
# Copyright (c) 2006 SUSE LINUX Products GmbH, Nuernberg, Germany.
# This file and all modifications and additions to the pristine
# package are under the same license as the package itself.
#
# Please submit bugfixes or comments via http://bugs.opensuse.org/
#

# norootforbuild
# neededforbuild  

BuildRequires:  aaa_base acl attr bash bind-utils bison bzip2 coreutils cpio cpp cracklib cvs cyrus-sasl db devs diffutils e2fsprogs file filesystem fillup findutils flex gawk gdbm-devel glibc glibc-devel glibc-locale gpm grep groff gzip info insserv kbd less libacl libattr libgcc libselinux libstdc++ libxcrypt m4 make man mktemp module-init-tools ncurses ncurses-devel net-tools netcfg openldap2-client openssl pam pam-modules patch permissions popt procinfo procps psmisc pwdutils rcs readline sed strace syslogd sysvinit tar tcpd texinfo timezone unzip util-linux vim zlib zlib-devel autoconf automake binutils gcc gdbm gettext libtool perl rpm

Name:           ksh
Url:            http://www.research.att.com/~gsf/download/
License:        Other License(s), see package
Group:          System/Shells
PreReq:         /bin/ln /etc/bash.bashrc
Autoreqprov:    on
Version:        93r
Release:        16.1
Summary:        Korn Shell
BuildRoot:      %{_tmppath}/%{name}-%{version}-build
Source:         INIT.2006-02-14.tar.bz2
Source1:        ast-ksh.2006-02-14.tar.bz2
Source2:        Agreement
Source3:        Warning
Patch:          ksh93.dif
Patch1:         workaround-stupid-build-system.diff
Patch2:         ksh-qemu.patch
Patch3:         ksh93-shift_ijs.dif
Patch4:         ksh93-gmt2utc.dif
Patch5:         ksh93-uname.dif
Patch6:         ksh93-vi.dif
Patch7:         ksh93-cut.dif

%description
The original Korn Shell.  The ksh is an sh-compatible command
interpreter that executes commands read from standard input or from a
file.



Authors:
--------
    David Korn <dgk@research.att.com>
    Glenn Fowler <gsf@research.att.com>
    Phong Vo <kpv@research.att.com>

%package -n ksh-devel
Summary:        Korn Shell development environment
Group:          System/Shells
Autoreqprov:    on

%description -n ksh-devel
The package includes C header files and the static libraries together
with the shared libraries for linking with other projects.  Please be
aware that the CPL licensed code can not be used within GPL licensed
project.



Authors:
--------
    David Korn <dgk@research.att.com>
    Glenn Fowler <gsf@research.att.com>
    Phong Vo <kpv@research.att.com>

%prep
%setup -n ksh93 -c -a 0 -a 1
%patch
%patch1
%ifarch %arm
%patch2
%endif
%patch3
%patch4
%patch5
%patch6
%patch7

%build
  #
  # If _you_ are knowing how to fix this in the autogenerated
  # sources of ksh/ast without breaking them, then let me know.
  #
  IGNORE="-Wno-missing-braces -Wno-unknown-pragmas -Wno-parentheses"
  IGNORE="$IGNORE -Wno-char-subscripts -Wno-uninitialized -Wno-implicit"
  #
  #
  FEATURE="-DSHOPT_SYSRC=1 -DSHOPT_REMOTE=1 -DSHOPT_CMDLIB_BLTIN=1"
  #
  #
  CCFLAGS="$RPM_OPT_FLAGS -D_GNU_SOURCE -fPIC -fno-strict-aliasing -g -pipe $IGNORE $FEATURE"
  LDFLAGS="-lm"
  HOSTTYPE=${RPM_ARCH%%*-linux*}
  CC=gcc
  mam_cc_L=use
  export CCFLAGS LDFLAGS CC mam_cc_L
  bin/package make
  root=$(echo ${PWD}/arch/linux*)
  test -d $root || exit 1
  log=${root}/lib/package/gen/make.out
  test -s $log || exit 1
  for lib in libast libcmd libdll libshell ; do
      obj=$(grep -E "ar *cr *${lib}.a" $log | sed "s@+ *ar *cr *${lib}.a@@")
      test $? -eq 0 || exit 1
      case "$lib" in
      libshell)
	  base=src/cmd/ksh93
	  vers=$(grep ^VERSION  ${base}/Makefile | sed "s@.*\([0-9]\+\.[0-9]\+\).*@\1@")
	  link="-L${root}/lib/ -Wl,-rpath,/%{_lib}/ast -last -lcmd -ldll"
	  ;;
      *)
	  base=src/lib/$lib
	  vers=$(grep :LIBRARY: ${base}/Makefile | sed "s@.*\([0-9]\+\.[0-9]\+\).*@\1@")
	  link=""
	  ;;
      esac
      soname="-Wl,-soname,${lib}.so.${vers%.*},-stats"
      pushd ${root}/${base}
      $CC -shared $soname -o ${root}/lib/${lib}.so.${vers} ${obj} $link
      ln -sf ${lib}.so.${vers} ${root}/lib/${lib}.so.${vers%.*}
      ln -sf ${lib}.so.${vers} ${root}/lib/${lib}.so
      popd
  done
  base=src/cmd/ksh93
  test=${PWD}/${base}/tests
  pushd ${root}/${base}
      ksh=$(grep -e '-o ksh' $log | tail -n 1 |\
	    sed "s@+ cc@gcc@;s@-o ksh@-o ${root}/bin/ksh@;s@[a-zA-Z0-9_/\.-]*lib\([a-z]\+\)\.a@-l\1@g")
      ${ksh} -static
      pushd ${test}
	  sleep 5
	  SHELL=${root}/bin/ksh ${root}/bin/ksh shtests
      popd
      rm -f ${root}/bin/ksh libshell.a
      ${ksh} -Wl,-rpath,/%{_lib}/ast
  popd

%install
  root=$(echo ${PWD}/arch/linux*)
  test -d $root || exit 1
  pushd $root || exit 1
  mkdir -p ${RPM_BUILD_ROOT}/bin
  mkdir -p ${RPM_BUILD_ROOT}/usr/bin
  mkdir -p ${RPM_BUILD_ROOT}/usr/include/ast
  mkdir -p ${RPM_BUILD_ROOT}/%{_lib}/ast
  mkdir -p ${RPM_BUILD_ROOT}%{_libdir}/ast
  mkdir -p ${RPM_BUILD_ROOT}%{_mandir}
  mkdir    ${RPM_BUILD_ROOT}%{_mandir}/man1
  mkdir    ${RPM_BUILD_ROOT}%{_mandir}/man3
  install bin/ksh ${RPM_BUILD_ROOT}/%{_lib}/ast/
  ln -sf /bin/true ${RPM_BUILD_ROOT}/bin/ksh
  ln -sf /bin/true ${RPM_BUILD_ROOT}/usr/bin/ksh
  ln -sf /%{_lib}/ast/ksh ${RPM_BUILD_ROOT}/usr/bin/rksh
  cp -a lib/*.so.*  ${RPM_BUILD_ROOT}/%{_lib}/ast/
  for so in ${RPM_BUILD_ROOT}/%{_lib}/ast/*.so.*.* ; do
      so=${so##*/}
      ln -sf /%{_lib}/ast/$so ${RPM_BUILD_ROOT}%{_libdir}/ast/${so%%%%.*}.so
  done
  rm -f ${RPM_BUILD_ROOT}%{_libdir}/ast/*.so.*
  install lib/*.a   ${RPM_BUILD_ROOT}%{_libdir}/ast/
  install man/man1/sh.1 ${RPM_BUILD_ROOT}%{_mandir}/man1/ksh.1
  for man in man/man3/*.3 ; do
      man=${man##*/}
      ast=${man}ast
      install man/man3/${man}  ${RPM_BUILD_ROOT}%{_mandir}/man3/${ast}
  done
  install include/ast/* ${RPM_BUILD_ROOT}/usr/include/ast/
  popd
  cp lib/package/LICENSES/ast LICENSE
  mv  src/cmd/ksh93/OBSOLETE src/cmd/ksh93/OBSOLETE.mm
  cat src/cmd/ksh93/builtins.mm | sed 's/\\f5/\\fB/g;s/^\.H/\.P\n\.H/g' | troff -Tascii8 -t -mm | grotty -bou > Builtins
  cat src/cmd/ksh93/PROMO.mm    | sed 's/\\f5/\\fB/g;s/^\.H/\.P\n\.H/g' | troff -Tascii8 -t -mm | grotty -bou > PROMO
  cat src/cmd/ksh93/OBSOLETE.mm | sed 's/\\f5/\\fB/g;s/^\.H/\.P\n\.H/g' | troff -Tascii8 -t -mm | grotty -bou > OBSOLETE
  cat src/cmd/ksh93/sh.memo     | sed 's/\\f5/\\fB/g;s/^\.H/\.P\n\.H/g' | troff -Tascii8 -t -mm | grotty -bou > MEMORANDUM
  cp %{SOURCE3} .

%post
test -e etc/bash.bashrc && ln -sf bash.bashrc etc/ksh.kshrc || true
if test -x  %{_lib}/ast/ksh ; then
    rm -f bin/ksh
    ln -sf /%{_lib}/ast/ksh bin/ksh
    rm -f usr/bin/ksh
    ln -sf /%{_lib}/ast/ksh usr/bin/ksh
fi

%postun
if test ! -x %{_lib}/ast/ksh ; then
    if test ! -x bin/pdksh ; then
	rm -f etc/ksh.kshrc
    fi
    if test ! -e bin/ksh ; then
	rm -f bin/ksh usr/bin/ksh
    fi
fi

%files
%defattr(-,root,root)
%doc LICENSE src/cmd/ksh93/COMPATIBILITY src/cmd/ksh93/RELEASE*
%doc Builtins PROMO OBSOLETE MEMORANDUM
%doc %{_mandir}/man1/ksh.1.gz
%ghost %verify(not link) /bin/ksh
%ghost %verify(not link) /usr/bin/ksh
/usr/bin/rksh
%dir /%{_lib}/ast/
/%{_lib}/ast/ksh
/%{_lib}/ast/*.so.*

%files -n ksh-devel
%defattr(-,root,root)
%doc LICENSE Warning
%dir %{_libdir}/ast/
%{_libdir}/ast/*.so
%{_libdir}/ast/*.a
%doc %{_mandir}/man3/*
/usr/include/ast/

%changelog -n ksh
* Mon Jul 10 2006 - werner@suse.de
- Don't trim backslash part of a multibyte character away (#189239)
* Tue Jul 04 2006 - werner@suse.de
- Builtin cut: allow last line without newline (#189231)
* Tue Jun 27 2006 - werner@suse.de
- No segmentation fault if ksh uses shared command libray (#188404)
* Wed May 31 2006 - werner@suse.de
- Fix segmentation fault in vi command line mode (bug #179917)
* Mon May 29 2006 - werner@suse.de
- Make -i and -p option of uname builtin work (bug #178962)
* Tue May 09 2006 - werner@suse.de
- Change PreRequire /bin/bash to /etc/bash.bashrc  (bug #172633)
* Mon May 08 2006 - werner@suse.de
- Correct order of souring order of the users profile and the
  system kshrc files (bug #172708)
* Wed Apr 19 2006 - werner@suse.de
- Do not source system rc files if ksh is not interactive
- Correct string from GMT to UTC for Universal Time Coordinates
* Wed Apr 19 2006 - werner@suse.de
- Fix the patch for the multi byte characters (bug #163665)
* Tue Apr 18 2006 - werner@suse.de
- Fix multi byte handling even for command line mode emacs/vi
* Thu Apr 06 2006 - werner@suse.de
- Handle multi byte characters within macro expansion (bug #163665)
* Mon Mar 27 2006 - werner@suse.de
- Update to ksh 93r
* Wed Jan 25 2006 - mls@suse.de
- converted neededforbuild to BuildRequires
* Tue Dec 20 2005 - werner@suse.de
- Move manual pages of libast to an own subsection 3ast (#140295)
* Fri Dec 16 2005 - werner@suse.de
- Make it build even with bash 3.1 and gcc 4.1.0
* Thu Nov 17 2005 - uli@suse.de
- disabled some tests on ARM (occasionally hang QEMU)
* Mon Oct 24 2005 - werner@suse.de
- PreReqire the bash to get the system wide bash.bashrc
* Mon Sep 19 2005 - werner@suse.de
- Make it compatible with parallel installed pdksh (bug #105126)
* Mon Sep 19 2005 - werner@suse.de
- Avoid useless gcc warning of autogenerated sources
* Tue Aug 16 2005 - werner@suse.de
- Move to group System/Shells (bug #104920)
* Wed Apr 13 2005 - werner@suse.de
- Make it compile with gcc4
* Thu Mar 24 2005 - werner@suse.de
- Correct initialization for got_sigwinch variable
* Wed Mar 23 2005 - werner@suse.de
- Update to release date 2005-02-02 (bug #18698, bug #74348)
* Wed Mar 09 2005 - werner@suse.de
- Fix dead link in documentation (bug #71733)
* Fri Feb 04 2005 - werner@suse.de
- More on winsize changes: now it works after a new prompt
  just like in the pdksh.
* Fri Feb 04 2005 - schwab@suse.de
- Workaround broken build system and enable building shared libraries on
  x86-64.
* Thu Feb 03 2005 - werner@suse.de
- Do not build shared version on x64_86 the ELF macro R_X64_86_32S
  breaks that a local symbol
- Make it work on s390x
* Thu Feb 03 2005 - werner@suse.de
- Make winsize changes work
- Enable /etc/ksh.kshrc support
- lchmod is not implemented under Linux
- error_exit does never return
- Enable shared libraries instead of the static ones
- Add a warning about CPL versus GPL
* Wed Feb 02 2005 - werner@suse.de
- Initial version of the AT&T ksh now under CPL1.0 (bug #3698)
